#include "main.h"
#include "ins_alt_elim.h"
#include "basico.h"

void inserir_alu(void){

  FILE *fp;
  ALUNO alu,alu2;
  char linha[80];
  long pos=0, registo=-1;
  int encontrou=0;

  system("clear");

  alu = le_alu();

  if( (fp=fopen(FIC_ALU,"r+b"))==NULL)
    if ( (fp=fopen(FIC_ALU,"w+b"))==NULL){
      fprintf(stderr,"Erro ao abrir o ficheiro %s\n",FIC_ALU);
      exit(0);
    }

  while(fread(&alu2,sizeof(ALUNO),1,fp)==1){
    if(alu2.num==-1 && encontrou==0){
      registo=pos;
      encontrou = 1;
    }
    if(alu.num==alu2.num){
      printf("\n ----> Esse aluno j existe! <---- \n");
      getchar();
      return;
    }
    pos = ftell(fp);
  }

  if(registo!=-1)
    fseek(fp,registo,SEEK_SET);

  if(fwrite(&alu,sizeof(ALUNO),1,fp)!=1){
    fprintf(stderr,"\n Erro ao escrever o regsito");
    exit(0);
  } 

  fclose(fp);
}



void inserir_tur(void){

  FILE *fp;
  TURMA tur,tur2;
  char linha[80];
  long pos=0, registo=-1;
  int encontrou=0, i;

  system("clear");
  tur = le_tur();

  if( (fp=fopen(FIC_TUR,"r+b"))==NULL)
    if ( (fp=fopen(FIC_TUR,"w+b"))==NULL){
      fprintf(stderr,"Erro ao abrir o ficheiro %s\n",FIC_TUR);
      exit(0);
    }

  while(fread(&tur2,sizeof(TURMA),1,fp)==1){
    if(tur2.num==-1 && encontrou==0){
      registo=pos;
      encontrou = 1;
    }
    if(tur.num==tur2.num){
      printf("\n ----> Essa turma j existe! <---- \n");
      getchar();
      return;
    }
    pos = ftell(fp);
  }

  if(registo!=-1)
    fseek(fp,registo,SEEK_SET);

  if(fwrite(&tur,sizeof(TURMA),1,fp)!=1){
    fprintf(stderr,"\n Erro ao escrever o registo");
    exit(0);
  } 

  fclose(fp);
}

void elim_alu(void){

  FILE *fp;
  char linha[80];
  int num,encontrou=0;
  ALUNO alu;
  char op;

  system("clear");
  printf("\n Nmero do aluno cujo registo pretende eliminar: ");
  fgets(linha,sizeof(linha),stdin);
  sscanf(linha,"%d",&num);

  system("clear");

  if ( (fp=fopen(FIC_ALU,"r+b"))==NULL){
    fprintf(stderr,"Erro ao abrir o ficheiro %s\n",FIC_ALU);
    getchar();
    return;
  }

  while(fread(&alu,sizeof(ALUNO),1,fp)==1){
    if(alu.num == num) {
      imprime_alu(alu);
      printf("\n\n----------------------------------------\n");
      printf("\n Tem a certeza (s/n)? ");
      fgets(linha,sizeof(linha),stdin);
      sscanf(linha,"%c",&op);
      if(op== 's' || op=='S'){
	alu.num = -1;
	fseek(fp,-sizeof(ALUNO),SEEK_CUR);
	if(fwrite(&alu,sizeof(ALUNO),1,fp)!=1)
	  printf("\n Erro ao escrever \n");
	else
	  printf("\n Registo eliminado com sucesso. \n");
      } else
	printf("\n Registo no eliminado \n");
    }
  }
  fclose(fp);
  printf("\n Prima <<ENTER>> para continuar");
  getchar();
}


void elim_tur(void){

  FILE *fp;
  char linha[80];
  int num,encontrou=0;
  TURMA tur;
  char op;

  system("clear");
  printf("\n Nmero da turma que pretende eliminar: ");
  fgets(linha,sizeof(linha),stdin);
  sscanf(linha,"%d",&num);

  system("clear");
  if ( (fp=fopen(FIC_TUR,"r+b"))==NULL){
    fprintf(stderr,"Erro ao abrir o ficheiro %s\n",FIC_TUR);
    getchar();
    return;
  }

  while(fread(&tur,sizeof(TURMA),1,fp)==1){
    if(num == tur.num){
      imprime_tur(tur);
      printf("\n\n----------------------------------------\n");
      printf("\n Tem a certeza (s/n)? ");
      fgets(linha,sizeof(linha),stdin);
      sscanf(linha,"%c",&op);
      if(op== 's' || op=='S'){
	tur.num = -1;
	fseek(fp,-sizeof(TURMA),SEEK_CUR);
	if(fwrite(&tur,sizeof(TURMA),1,fp)!=1)
	  printf("\n Erro ao escrever \n");
	else
	  printf("\n Registo eliminado com sucesso. \n");
      } else
	printf("\n Registo no eliminado \n");
    }
  }
  fclose(fp);
  printf("\n Prima <<ENTER>> para continuar");
  getchar();
  
}
void alterar_alu(void){

  FILE *fp;
  char op;
  int i,num;
  char linha[80];
  ALUNO alu,alu2;

  system("clear");

  printf("\n Nmero de inscrio do aluno a alterar: ");
  fgets(linha,sizeof(linha),stdin);
  sscanf(linha,"%d",&num);  
  
  if(pesq_alu2(num)!=0){
    printf("\n\n\n\n Insira novos valores\n");
    alu = le_alu();
    
    if ( (fp=fopen(FIC_ALU,"r+b"))==NULL){
      fprintf(stderr,"Erro ao abrir o ficheiro %s\n",FIC_ALU);
      getchar();
      return;
    }
    
    while(fread(&alu2,sizeof(ALUNO),1,fp)==1){
      if(alu2.num == num) {
	printf("\n Tem a certeza (s/n)? ");
	fgets(linha,sizeof(linha),stdin);
	sscanf(linha,"%c",&op);
	if(op== 's' || op=='S'){
	  fseek(fp,-sizeof(ALUNO),SEEK_CUR);
	  if(fwrite(&alu,sizeof(ALUNO),1,fp)!=1)
	    printf("\n Erro ao escrever \n");
	  else
	    printf("\n Registo alterado com sucesso. \n");
	} else
	  printf("\n Registo no alterado \n");
      }
    }
    fclose(fp);
  }

  printf("\n Prima <<ENTER>> para continuar");
  getchar();  
  

}

void alterar_tur(void){

  FILE *fp;
  char op;
  int i,num;
  char linha[80];
  TURMA tur,tur2;

  system("clear");

  printf("\n Nmero da turma a alterar: ");
  fgets(linha,sizeof(linha),stdin);
  sscanf(linha,"%d",&num);  
  
  if(pesq_tur2(num)!=0){
    printf("\n\n\n\n Insira novos valores\n");
    tur = le_tur();
    
    if ( (fp=fopen(FIC_TUR,"r+b"))==NULL){
      fprintf(stderr,"Erro ao abrir o ficheiro %s\n",FIC_TUR);
      getchar();
      return;
    }
    
    while(fread(&tur2,sizeof(TURMA),1,fp)==1){
      if(tur2.num == num) {
	printf("\n Tem a certeza (s/n)? ");
	fgets(linha,sizeof(linha),stdin);
	sscanf(linha,"%c",&op);
	if(op== 's' || op=='S'){
	  fseek(fp,-sizeof(TURMA),SEEK_CUR);
	  if(fwrite(&tur,sizeof(TURMA),1,fp)!=1)
	    printf("\n Erro ao escrever \n");
	  else
	    printf("\n Registo alterado com sucesso. \n");
	} else
	  printf("\n Registo no alterado \n");
      }
    }
    fclose(fp);
  }

  printf("\n Prima <<ENTER>> para continuar");
  getchar();  
  
}

